#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>

char * fname = "../nis/.pwd.lock";

int main (int argc, char ** argv )
{
    int ten;
    int fd = open ( fname, O_RDWR);
    struct flock lock;

    if ( fd < 0 )
    {
        fprintf ( stderr, "Can't open %s\n", fname );
        return (1);
    }

    lock.l_type = F_WRLCK;
    lock.l_start = 0;
    lock.l_whence = SEEK_SET;
    lock.l_len = 0; /* whole file */

    if ( fcntl ( fd, F_SETLKW, &lock) < 0 )
    {
        fprintf ( stderr, "Can't lock %s\n", fname );
        close ( fd );
        return (2);
    }

    system ( "/bin/vi ../nis/passwd" );

    lock.l_type = F_UNLCK;

    if ( fcntl ( fd, F_SETLK, &lock) < 0 )
    {
        fprintf ( stderr, "Can't unlock %s\n", fname );
        close ( fd );
        return (2);
    }
    close ( fd );
    return (0);
}
